/* dffingerd by drt@ailis.de
 *
 * create directory structure for using dffingerd with svscan
 *
 * You might find more Info at http://drt.ailis.de/
 * 
 * I do not belive there is a thing like copyright.
 *
 * $Log: dffingerd-conf.c,v $
 * Revision 1.1  2000/04/08 08:53:57  drt
 * Initial revision
 *
 */

#include <pwd.h>
#include "djb/strerr.h"
#include "djb/exit.h"
#include "djb/auto_home.h"
#include "djb/generic-conf.h"

static char *rcsid="$Id: dffingerd-conf.c,v 1.1 2000/04/08 08:53:57 drt Exp drt $";

#define FATAL "dffingerd-conf: fatal: "

void usage(void)
{
  strerr_die1x(100,"dffingerd-conf: usage: dffingerd-conf acct logacct /dffingerd myip");
}

char *dir;
char *user;
char *loguser;
struct passwd *pw;
char *myip;

int main(int argc, char **argv)
{
  user = argv[1];
  if (!user) usage();
  loguser = argv[2];
  if (!loguser) usage();
  dir = argv[3];
  if (!dir) usage();
  if (dir[0] != '/') usage();
  myip = argv[4];
  if (!myip) usage();

  pw = getpwnam(loguser);
  if (!pw)
    strerr_die3x(111,FATAL,"unknown account ",loguser);

  init(dir,FATAL);
  makelog(loguser,pw->pw_uid,pw->pw_gid);

  start("run");
  outs("#!/bin/sh\nexec 2>&1\n");
  outs("ROOT="); outs(dir); outs("/root; export ROOT\n");
  outs("IP="); outs(myip); outs("; export IP\n");
  outs("exec envuidgid "); outs(user);
  outs(" \\\nsoftlimit -d250000");
  outs(" \\\ntcpserver $IP finger");
  outs(" "); outs(auto_home); outs("/bin/dffingerd");
  outs("\n");
  finish();
  perm(0755);

  makedir("root");
  perm(02755);

  makedir("root/data");
  perm(02755);

  start("root/Makefile");
  outs("data.cdb: data/*\n");
  outs("\t"); outs(auto_home); outs("/bin/dffingerd-data\n");
  finish();
  perm(0644);

  return 0;
}
